# filter pairs with 1tag & 1charge, 1charge & 2tag, 2charge & 2tag
# Usage:
#       pkselect<-ctFilter(pklist,mzTol);
#             
# Update:
#       Apr 22, 2013 : first coded

ctFilter<-function(pklist,mzTol=15e-6)
{
  pklist<-as.data.frame(pklist);
  mzH<-1.007276
  chargeVec<-pklist$nCharge;
  tagVec<-pklist$nTag; 
  mzVec<-pklist$mz_light;
  ind11<-which(chargeVec==1 & tagVec==1)
  ind22<-which(chargeVec==2 & tagVec==2)
  ind12<-which(chargeVec==1 & tagVec==2)
  mz12<-mzVec[ind12]
  scanNo22<-pklist$scanNum[ind22]
  scanNo12<-pklist$scanNum[ind12]

  num22<-length(ind22)
  isRemove22<-vector(mode='logical',length=num22);
  
  for (n in 1:num22)
  {
      mzC22<-mzVec[ind22[n]]
      scanNoC<-scanNo22[n]
      # consider same scan number?
      indtmp<-which(abs(mz12-2*mzC22-mzH)<=mzTol*mzC22 & scanNo12==scanNoC)
      if (length(indtmp)>0)
      {
         isRemove22[n]<-TRUE
      }
  }
  indKeep<-c(ind11,ind12,ind22[which(isRemove22==FALSE)])
  #return(pklist[indKeep,]);
  # sorted
  pklist<-pklist[indKeep,]
  pk.sorted <- pklist[order(pklist$scanNum,pklist$mz_light,decreasing=FALSE), ]; rm(pklist)
  return (pk.sorted)
}
