# remove pairs with a lighter/background mz_light
# Usage:
#       pkNew<-mzCutoff(pkOld);
# Update:
#       Mar31, 2012 : first coded removeLightMZ
#       Nov23, 2012 : renamed to mzCutoff

mzCutoff<-function(pklist,mzListFile=NA)
{
  if (!is.na(mzListFile))
  {
     pklist<-as.data.frame(pklist);
     minMZ<-scan(mzListFile,sep=',',quiet=TRUE)
     minMZ<-matrix(minMZ,4,4); 
     isRemove<-vector(mode='logical',length=nrow(pklist));
     for (nc in 1:4)
     {
         for (nt in 1:4)
         {
             indtmp<-which(pklist$nCharge==nc & pklist$nTag==nt);
             mzVectmp<-pklist$mz_light[indtmp];
             isRemove[indtmp[mzVectmp<minMZ[nt,nc]]]<-TRUE
         }
     }
     # print total removed pairs
     print(paste("  removeLighterMZ.R: total removed lighter-mz pairs: ",length(which(isRemove==TRUE)),sep=""))
     return(pklist[which(isRemove==FALSE),]);
  } else {
     return(pklist);
  }
}
