# remove the unkown backgroud pairs using a mzTol
# Usage:
#       pkNew<-mzFilter(pkOld,mzFilterFile=NA,mzTol);
#             
# Update:
#       Nov24, 2012 : first coded

mzFilter<-function(pklist,mzFilterFile=NA,mzTol=10e-6)
{
  if (! is.na(mzFilterFile))
  {
     if (file.exists(mzFilterFile))
     {
        pklist<-as.data.frame(pklist);
        chargeVec<-pklist$nCharge;
        tagVec<-pklist$nTag;      #bug fixed by Ronghong on Jan 11, 2013
        mzVec<-pklist$mz_light;
        mzFiltered<-read.csv(mzFilterFile,sep=",",header=TRUE);
        isRemove<-vector(mode='logical',length=nrow(pklist));
        for (nr in 1:nrow(mzFiltered))
        {
            tmpMZ<-mzFiltered$mz_light[nr]
            nCharge<-mzFiltered$nCharge[nr]
            nTag<-mzFiltered$nTag[nr]
            mzTolTmp<-mzTol*tmpMZ;
            indtmp<-which( chargeVec==nCharge & tagVec==nTag & abs(mzVec-tmpMZ)<mzTolTmp );
            if (length(indtmp)>0)
            {
               isRemove[indtmp]<-TRUE
            }
        }
        # print total removed pairs
        print(paste("  mzFilter: total removed pairs: ",length(which(isRemove==TRUE)),sep=""))
        return(pklist[which(isRemove==FALSE),]);
     } else {
       return(pklist);
     }
  } else {
    return(pklist);
  }
}
