# remove the unkown backgroud peaks based on mz and a mzTol before peak pairing
# Usage:
#       pkNew<-mzFilterBackground(pkOld,mzFilterFile=NA,mzTol);
#             
# Update:
#       May    2013: first coded for raw data [using mz field]
#       May12  2013: modified for peak pair [ using mz_light field]

mzFilterBackground<-function(pklist,mzFilterFile=NA,mzTol=15e-6)
{
  if (! is.na(mzFilterFile))
  {
     if (file.exists(mzFilterFile))
     {
        pklist<-as.data.frame(pklist);
        mzVec<-pklist$mz_light;
        mzFiltered<-read.csv(mzFilterFile,sep=",",header=TRUE);
        isRemove<-vector(mode='logical',length=nrow(pklist));
        for (nr in 1:nrow(mzFiltered))
        {
            tmpMZ<-mzFiltered$mz[nr]  # Note the filed in mzBackground.csv
            mzTolTmp<-mzTol*tmpMZ;
            indtmp<-which(abs(mzVec-tmpMZ)<mzTolTmp );
            if (length(indtmp)>0)
            {
               isRemove[indtmp]<-TRUE
            }
        }
        # print total removed pairs
        print(paste("  mzFilterBackground: total removed pairs: ",length(which(isRemove==TRUE)),sep=""))
        return(pklist[which(isRemove==FALSE),]);
     } else {
       return(pklist);
     }
  } else {
    return(pklist);
  }
}
